#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ lex_assoc_test.apl  APL workspace to test lex_assoc
⍝ Copyright (C) 2020 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************
)copy 1 lex_assoc
)copy 1 assert

∇test∆lexa;tst
  ⍝ Function to the test lex_assoc workspace
  tst←⊂'t1←lexa∆init 37'
  tst←tst,⊂'t1←t1 lexa∆assign ''one'' 1'
  tst←tst,⊂'t2←1  2⍴ ''one'' 1'
  tst←tst,⊂'t1←t1 lexa∆assign ''two'' 2'
  tst←tst,⊂'t1←t1 lexa∆assign ''three'' ''seventeen'''
  assert∆setup tst
  assert∆true assert∆toScreen 'lexa∆is t1'
  assert∆false assert∆toScreen 'lexa∆is t2'
  assert∆true assert∆toScreen 't1 lexa∆haskey ''one'''
  assert∆false assert∆toScreen 't1 lexa∆haskey ''four'''
  assert∆false assert∆toScreen 'lexa∆isempty t1'
  assert∆true assert∆toScreen 'lexa∆isempty lexa∆init 37'
  1 assert∆toScreen 't1 lexa∆lookup ''one'''
  2 assert∆toScreen 't1 lexa∆lookup ''two'''
  'seventeen' assert∆toScreen 't1 lexa∆lookup ''three'''
  assert∆setup 't3←lexa∆from_alist ''five'' 18 ''six'' 178.553 ''seven'' '''''
  ⍬ assert∆toScreen 't3 lexa∆lookup ''one'''
  178.553 assert∆toScreen 't3 lexa∆lookup ''six'''
  'five' 'six' 'seven' assert∆toScreen 'lexa∆keys t3'
  assert∆setup 't4←'':;'' lexa∆from_delim ''eight:766375.8;nine:18;ten:Square root of 5'''
  '18' assert∆toScreen 't4 lexa∆lookup ''nine'''
∇
⍝)off

